#include<bits/stdc++.h>
using namespace std;
int main ()
{
    long long n;
    cin>>n;

    long long a[n+10];
    long long b[n+10];
    long long p[n+10];

    for (long long i=1; i<=n; i++)
    {
        cin>>a[i]>>b[i];
    }
    for (long long i=1; i<=n; i++) cin>>p[i];
    
    long long dp[n+10];

    long long ans=0;
    long long sum=0;
    if (p[1]!=-1)
    {
        for (long long i=1; i<=min(p[1], n); i++)
        {
            sum+=a[i];
            ans=max(ans, sum);
        }
    }
    else
    {
        for (long long i=1; i<=n; i++)
        {
            sum+=a[i];
            ans=max(ans, sum);
        }
    }
    
    cout<<ans<<endl;
    return 0;
}
